config/routes.rb
Rails.application.routes.draw do
  root to: "home#index"
  resources :artefacts
  resources :tasks
  resources :bpmn_processes
  get :uploads, :controller => :uploads, :action => :index
  get :report, to: 'report#index', as: :report
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/controllers/bpmn_processes_controller.rb
class BpmnProcessesController < ApplicationController
  require "rexml/document"
  include REXML
  before_action :set_bpmn_process, only: [:show, :edit, :update, :destroy]

  # GET /bpmn_processes
  # GET /bpmn_processes.json
  def index
    @bpmn_processes = BpmnProcess.all
  end

  # GET /bpmn_processes/1
  # GET /bpmn_processes/1.json
  def show
  end

  # GET /bpmn_processes/new
  def new

  end

  # GET /bpmn_processes/1/edit
  def edit
  end

  # POST /bpmn_processes
  # POST /bpmn_processes.json
  def create

    begin
      file = File.new(params[:file].path)
      doc = Document.new file

      #Goes through the whole bpmn file looking for the desired data hierarchically
      doc.elements.each("*/process") { |process|

        #Gets all artefacts of this process
        artefacts = []
        process.elements.each('dataObject') {|artefact| artefacts << Artefact.new(name: artefact.attributes['name'], original_id: artefact.attributes['id']) }

        #Gets all associatins of this process
        associations = []
        process.elements.each('association') {|association| associations << {sourceRef: association.attributes['sourceRef'], targetRef: association.attributes['targetRef']}}

        new_process =  BpmnProcess.new(name: process.attributes['name'] == nil ? "undefined" : process.attributes['name'], original_id: process.attributes['id'])

        #Goes through every task in the file
        process.elements.each('task') { |task|

          new_task = Task.new(name: task.attributes['name'] == nil ? "undefined" : task.attributes['name'] , original_id: task.attributes['id'])

          #Looks for all associations of this task
          task_associations = associations.find_all {|a| a[:sourceRef] == new_task.original_id }
          if (task_associations)
            #If associations were found, then it creates an array with all target references from them (target_refs)
            target_refs = task_associations.map { |association| association[:targetRef] }
            #It also creates an array of artefacts for those artefacts that have their original id as any of the target references numbers
            task_artefacts = artefacts.find_all {|a| target_refs.include? a.original_id }
            if (task_artefacts)
              #If artefacts were found for this task, then it will be included as its children
              new_task.artefacts = task_artefacts
            end
          end

          #includes this task in the process to be saved later
          new_process.tasks << new_task

          }

        #Looks for sequences flows to determine the execution order of each activity later
        process.elements.each('sequenceFlow') {|sequenceFlow|
          new_sequence = SequenceFlow.new(original_id: sequenceFlow.attributes['id'], sourceRef: sequenceFlow.attributes['sourceRef'], targetRef: sequenceFlow.attributes['targetRef'])
          new_process.sequence_flows << new_sequence
        }
          #Finally saves the process, its tasks (and artefacts) in the database
        new_process.save
      }
      flash[:notice] = "BPMn was successfully imported"
      redirect_to bpmn_processes_url
    rescue
      flash[:alert] = "Failed to import BPMn"
      redirect_to bpmn_processes_url
    end
  end

  # PATCH/PUT /bpmn_processes/1
  # PATCH/PUT /bpmn_processes/1.json
  def update
    respond_to do |format|
      if @bpmn_process.update(bpmn_process_params)
        format.html { redirect_to @bpmn_process, notice: 'Bpmn process was successfully updated.' }
        format.json { render :show, status: :ok, location: @bpmn_process }
      else
        format.html { render :edit }
        format.json { render json: @bpmn_process.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /bpmn_processes/1
  # DELETE /bpmn_processes/1.json
  def destroy
    @bpmn_process.destroy
    respond_to do |format|
      format.html { redirect_to bpmn_processes_url, notice: 'Bpmn process was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_bpmn_process
      @bpmn_process = BpmnProcess.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def bpmn_process_params
      params.require(:bpmn_process).permit(:name)
    end
end

app/helpers/bpmn_processes_helper.rb
module BpmnProcessesHelper
end

app/views/bpmn_processes/_form.html.erb
<%= form_for(bpmn_process) do |f| %>
  <% if bpmn_process.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(bpmn_process.errors.count, "error") %> prohibited this bpmn_process from being saved:</h2>

      <ul>
      <% bpmn_process.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :name %>
    <%= f.text_field :name %>
  </div>

  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/bpmn_processes/edit.html.erb
<h1>Editing Bpmn Process</h1>

<%= render 'form', bpmn_process: @bpmn_process %>

<%= link_to 'Show', @bpmn_process %> |
<%= link_to 'Back', bpmn_processes_path %>

app/views/bpmn_processes/index.html.erb
<h1>Processes</h1>

<%= link_to 'New Bpmn Process', new_bpmn_process_path %>
<% if notice %>
  <p class="alert alert-success"><%= notice %></p>
<% end %>

<% if alert %>
  <p class="alert alert-danger"><%= alert %></p>
<% end %>

<table class="table table-bordered">
  <thead>
    <tr>
      <th>Name</th>
      <th>Original Id</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @bpmn_processes.each do |bpmn_process| %>
      <tr>
        <td><%= link_to bpmn_process.name, bpmn_process_path(bpmn_process) %></td>
        <td><%= bpmn_process.original_id %></td>
        <td><%= link_to 'Destroy', bpmn_process, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/bpmn_processes/new.html.erb
<article>
	<h1>Import a BPMn file</h1>
	<%= flash[:notice] %>

	<%= form_tag bpmn_processes_path, method: :post , multipart: true do %>
		<%= file_field_tag :file %>
	  <br />
		<%= submit_tag "Submit" %>
		<% end %>
</article>

app/views/bpmn_processes/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @bpmn_process.name %>
</p>

<%= link_to 'Edit', edit_bpmn_process_path(@bpmn_process) %> |
<%= link_to 'Back', bpmn_processes_path %>